var Api = require('../../utils/api.js');
var app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    hidden: true,
    addBtn:false,
    oid:"",  // 用于身份转换
    result:[],
    hospitalName:'',
    record: false,
    animate: true,
    deleteModal: true,
    hiddenUSer: true,
    showUser: -1,
    animationData: {},
    checkDetail: 0,//查看明细
    maFlag: 1,// 是不是超级管理员
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options){
    let that = this;
    wx.setNavigationBarTitle({
      title: "添加成员"
    })
    var allData = wx.getStorageSync('data');
    var hospitalmoney = wx.getStorageSync('hospitalmoney');
    if (hospitalmoney.hospitalname){
      this.setData({
        hospitalName: hospitalmoney.hospitalname
      })
    }
    wx.showLoading({
      title: '正在生成',
    })
    // var url = Api.HOST + 'wechat.php?s=/Measure/add_admin';
    var url = Api.HOST + 'wechat.php?s=/Measure/add_member';
    var data = {};
    data.unitid = allData.unitid;
    data.openid = allData.openid;
    Api.fetchPost(url, data, (err, res) => {
      wx.hideLoading()
      if(res){
        that.setData({ photo: res.data })
      }else{
      }
      
    })
  },
  addBtn: function(){
    // this.setData({ addBtn:true})
    let that = this;
    var user = wx.getStorageSync('user');
    var url = Api.HOST + 'wechat.php?s=/Measure/admin_list';
    var data = {};
    if (user.unitid == 0 || user.unitid == null){
      return;
    }
    data.unitid = user.unitid;
    data.openid = user.openid;
    Api.fetchPost(url, data, (err, res) => {
      console.log(res,'res')
      if(res.length == 0){
        that.setData({
          record: true,
          result:[],
          showUser: 1
        });
        return;
      }else{
        that.setData({ addBtn: true })
      }
      var arr=[];
      for (let i = 0; i < res.length; i++) {
        res[i].createtime = Api.timestampToTime(res[i].createtime);
        res[i].id = Number(res[i].id)
        var json = {
          openid: res[i].openid,
          name: res[i].name,
          headimgurl: res[i].headimgurl,
          createtime: res[i].createtime,
          id:i,
          marketstatus: res[i].marketstatus
        }
        arr.push(json)
      }
     that.setData({ result: arr, showUser:0})
    })
  },
 
  userdelete: function(e){
    let that = this;
    var num = e.currentTarget.dataset.oid;
    var oid = e.currentTarget.dataset.id
    console.log(num,'num')
    this.setData({hidden:false,num:num,oid:oid})
    
  },
  confirm() {
    this.setData({
      hidden: true,
      falg: true
    })
    let that = this;
    var url = Api.HOST + 'wechat.php?s=/Measure/admin_del';
    var data = {};
    console.log(that.data.oid)
    if (!that.data.oid) {
      return;
    }
    data.openid = that.data.oid;
    Api.fetchPost(url, data, (err, res) => {
      console.log(res, 'res')
      if(res == 1){
        that.setData({
          animate: true,
          deleteModal: true
        })
      }
    })
    this.onLoad();
  },
  selectInfo: function(e){
    var id = e.currentTarget.dataset.oid;
    wx.navigateTo({
      url: '/pages/setperm/setperm?oid='+id,
    })
    console.log(e)
  },
  cancel() {
    this.setData({
      hidden: true
    })
  },
  cancelUser(){
    this.setData({
      hiddenUSer: true
    })
  },
  confirmUser(){
    wx.navigateTo({
      url: '/pages/user/user?share=1',
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    let that = this;
    wx.getSystemInfo({
      success: (res) => {
        if (/^iPhone X.*/i.test(res.model) || res.model.indexOf("Plus") != -1) {
          that.setData({
            iPhoneX: true,
            winH: res.windowHeight
          })
        } else {
          that.setData({
            iPhoneX: false,
            winH: res.windowHeight
          })
        }
      }
    });
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // var allData = wx.getStorageSync('data');
    this.setData({
      animate: true,
      // 
      deleteModal: true,
      hidden: true,
      hiddenUSer: true
    })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {
  
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
  
  },
  changeName: function(){
    
  },
  // 下拉刷新
  onPullDownRefresh: function () {
    this.freshData();
  },
  freshData: function(){
    let that = this;
    var user = wx.getStorageSync('user');
    var url = Api.HOST + 'wechat.php?s=/Measure/admin_list';
    var data = {};
    data.unitid = user.unitid;
    data.openid = user.openid;
    Api.fetchPost(url, data, (err, res) => {
      console.log(res, 'res')
      wx.stopPullDownRefresh()
      if (res.length == 0) {
        that.setData({
          record: true
        });
        return;
      } else {
        that.setData({ addBtn: true })
      }
      var arr = [];
      for (let i = 0; i < res.length; i++) {
        res[i].createtime = Api.timestampToTime(res[i].createtime);
        res[i].id = Number(res[i].id)
        var json = {
          openid: res[i].openid,
          name: res[i].name,
          headimgurl: res[i].headimgurl,
          createtime: res[i].createtime,
          id: i
        }
        arr.push(json)
      }

      console.log(res, 'arr')
      that.setData({ result: arr })
    })
  },
  // 长按转换身份
  changeIdent: function(e,name){
    let that = this;
    // console.log(e,"长按")
    var oid = e;
    that.setData({ oid: oid,showname: name })
    wx.navigateTo({
      url: '/pages/user/user?share=1',
    })
  },
  addBtnUp: function(){
    wx.navigateTo({
      url: '/pages/setAddm/setAddm',
    })
    // this.addBtn()
    // this.setData({
    //   animate: false
    // })
    // let winH = this.data.winH;
    // this.animat(250,-winH);
  },
  closeList: function(){
    this.animat(200, 0)
    setTimeout(() => {
      this.setData({
        animate: true
      })
    }, 200)
  },
  modalList: function(){
    console.log('modalList')
  },
  warpModal: function(e){
    console.log(e)
    var win = e.target.dataset.id;
    if(win){
      this.animat(200, 0)
      setTimeout(() => {
        this.setData({
          animate: true
        })
      }, 200)
    }
  },
  userBtn: function(e){
    var win = e.target.dataset.id;
    if (win) {
      this.setData({
        deleteModal: true
      })
    }
  },
  /* 调起编辑弹出框
  *   参数 1
        身份转让的参数
  *
  */
  deleteUp: function(e){
    console.log(e,'e')
    let that = this;
    var num = e.currentTarget.dataset.idnum; // oid -- openid
    var oid = e.currentTarget.dataset.oid; // id--index
    var nameUser = e.currentTarget.dataset.name; // name -- name
    let maFlag = e.currentTarget.dataset.m;
    this.checkStuts(oid); // 获取查看明细信息
    this.setData({
      deleteModal: false, num: num, oid: oid, nameUser: nameUser, animate: false, maFlag: maFlag
    })
  },
  // 删除管理员按钮---调起警告框
  deleteUser: function(){
    this.setData({
      hidden: false,
    })
  },
  // 取消编辑层
  cancelModal: function(){
    this.setData({
      deleteModal: true
    })
  },
  // 转让身份
  zhuanUser:function(){
    var n = this.data.oid;
    var name = this.data.nameUser;
    this.setData({ oid: n, showname: name })
    this.setData({
      hiddenUSer: false
    })
  },
  animat: function (duration, n) {
    let animation = wx.createAnimation({
      duration: duration,
      timingFunction: 'linear'
    })
    animation.translate(0, n).step()
    this.setData({
      animationData: animation.export(),
    })
  },
  checkStuts(oid){
    let that = this;
    var allData = wx.getStorageSync('data');
    var url = Api.HOST + 'wechat.php?s=/Measure/transaction';
    var data = {};
    data.openid = oid;
    data.unitid = allData.unitid;
    data.transaction = 
    Api.fetchPost(url, data, (err, res) => {
      that.setData({ checkDetail: res})
      console.log('是否查看明细状态',res)
    })
  },
  checkDetail(){
    let that = this;
    var allData = wx.getStorageSync('data');
    var checkDetail = this.data.checkDetail;
    var check = 0;
    if (Number(checkDetail) == 0){
      this.setData({
        checkDetail: 1
      })
      check = 1;
    }else{
      this.setData({
        checkDetail: 0
      })
    }
    // console.log(this.data.checkDetail)
    // 
    var url = Api.HOST + 'wechat.php?s=/Measure/edit_transaction';
    var data = {};
    data.openid = this.data.oid;
    data.unitid = allData.unitid;
    data.transaction = check;
    Api.fetchPost(url, data, (err, res) => {
      that.setData({ deleteModal: true })
      wx.showToast({
        title:'修改成功',
        icon:'success',
        duration: 2000
      })
      // setTimeout(()=>{
       
      // },2000)
      console.log('是否查看明细',res)
    })

  },
  changeUser(){
    let that = this;
    var allData = wx.getStorageSync('data');
    var url = Api.HOST + 'wechat.php?s=/Measure/super_admin';
    var data = {};
    wx.showLoading({
      title: '正在设置',
    })
    data.openid = this.data.oid;
    data.unitid = allData.unitid;
    Api.fetchPost(url, data, (err, res) => {
        console.log(res)
        wx.hideLoading();
        if(res){
          if(res.ret == 1){
           
            let num = that.data.num;
            let result = that.data.result.map((item,index)=>{
              item.marketstatus = 1;
              return item;
            })
            that.setData({
              animate: false,
              deleteModal: true,
              result: result
            })
          }
        }
    })
  }
})