import {debouce,isEmpty,formatSeconds} from '../../utils/util'
import answerData from '../../utils/scale/dati08Data.js'
import {fetchPostN,fetchPost,HOST_xinli,HOST} from '../../utils/api'
import {
  checkAnswerRecord,
  sendAnswerScore,
	sendAnswerOption
} from '../../utils/scale/dati08.js'
import datiTestData from '../../utils/scale/dati08TestData'
Page({
  data: {
    currentIndex: 0,
    scaleData: {}, //量表信息数据
    scaleTitleData: [], //量表标题数据
    questionData: [], //量表题目数据
    answerRecord: [], //答题记录
    isCanSubmit: false, //是否可以提交，要保证数据的完整
    isCanClick: true, //是否可点击题目，因为点击是延时200毫秒，用户可能点的过快
    takeTime: 0, //答题所用时间
    takeTimeTimer: null, //答题计时器
    flag: true, //原逻辑提交方法用的数据
    disab: false,

    //原逻辑的数据，看不懂
		//1为监测
		inquiry: '',
		//1二维码。2聊天页面心理体检
		inquiry_id: '' //心理体检量表ID
  },
  onLoad: function (options) {
    let data = wx.getStorageSync('lb_swiper_con') //取出缓存中量表的数据
    //let data = datiTestData  //写死的测试数据
    if (!isEmpty(data) && data.length === 2) {
      this.setData({
        scaleData: data[0]
      })
      this.initData(data[1])
      console.log(this.data.scaleTitleData.length)
    }

    //原逻辑的参数，看不懂
			if (options.inquiry) {
				this.inquiry = options.inquiry
				this.inquiry_id = options.inquiry_id

			} else {
				this.inquiry = 1
			}
  },
  onShow: function () {
    let takeTimeCache = wx.getStorageSync('takeTime05')
    if (takeTimeCache && !isNaN(parseInt(takeTimeCache))) {
      this.setData({
        takeTime: takeTimeCache
      })
    }
    //开启答题计时器
    this.data.takeTimeTimer = setInterval(() => {
      this.setData({
        takeTime:this.data.takeTime+1
      })
    }, 1000)
  },
  onHide: function () {
    //页面隐藏时关闭答题计时器，并将最新时间戳存入缓存
    if (!!this.data.takeTimeTimer) {
      clearInterval(this.data.takeTimeTimer)
      wx.setStorageSync('takeTime05', this.data.takeTime)
    }
  },
  onUnload: function () {
    //页面卸载时关闭答题计时器，并将最新时间戳存入缓存
    if (!!this.data.takeTimeTimer) {
      clearInterval(this.data.takeTimeTimer)
      wx.setStorageSync('takeTime05', this.data.takeTime)
    }
  },
  //初始化量表数据
  initData(data) {
    if (isEmpty(data) || data.length === 0) {
      this.setData({
        questionData:[]
      })
    } else {
      this.setData({
        questionData:answerData
      })
    }
    //取出缓存中答题记录(续答功能)
    let answerRecordCache = wx.getStorageSync('answerRecordCache05')
    let scaleTitleData = []
    if (answerRecordCache) {
      
      data.forEach((value, index) => {
        scaleTitleData.push(value.quesion_title)
      })
      this.setData({
        scaleTitleData:scaleTitleData,
        currentIndex:answerRecordCache.currentIndex,
        answerRecord:answerRecordCache.answerRecord
      })
    } else {
      let answerRecord = []
      data.forEach((value, index) => {
        scaleTitleData.push(value.quesion_title)
        answerRecord.push({}) //初始化答题记录数据，到时候直接往这个对象里写对应的索引和值
      })
      this.setData({
        scaleTitleData:scaleTitleData,
        answerRecord:answerRecord
      })
    }
  },
  //点击选项
  selectOption(e) {
    let parameter = e.currentTarget.dataset
    let contentItem = parameter.contentItem
    let answerIndex = parameter.answerIndex
    let contentIndex = parameter.contentIndex
    let currentIndex = this.data.currentIndex
    let scaleTitleIndex = parameter.scaleTitleIndex
    if (this.data.isCanClick === false) {
      return
    }
    if(scaleTitleIndex != currentIndex){
      return
    }
    if(this.data.questionData[answerIndex].isShow === false){
      return
    }
    this.setData({
      isCanClick:false
    })
    //下面延时200毫秒是给用户一个反应的时间
    if (contentItem.toIndex === 0) {
      //将选项存入答题记录，同时更新视图内容
      let record = this.data.answerRecord[currentIndex]
      record[answerIndex] = {
        index: contentIndex,
        score: contentItem.score
      }
      this.setData({
        [`answerRecord[${currentIndex}]`] : record
      })
      let timer = setTimeout(() => {
        this.setData({
          isCanClick:true
        })
        //最后一题的时候返回
        if (currentIndex + 1 === this.data.scaleTitleData.length) {
          //判断是否可以提交了
          this.canSubmit()
        } else {
          this.setData({
            currentIndex:currentIndex+1
          })
          //答题记录写入缓存(续答功能)
          wx.setStorageSync('answerRecordCache05', {
            currentIndex: this.data.currentIndex,
            answerRecord: this.data.answerRecord
          })
          //每答完一题缓存里记录最新的答题时间
          wx.setStorageSync('takeTime05', this.data.takeTime)
          this.isShowToFalse()
          this.setData({
            [`questionData[0].isShow`]:true
          })
        }
        clearTimeout(timer)
      },200)
    } else {
      //将选项存入答题记录，同时更新视图内容，记录答题
      let record = this.data.answerRecord[this.data.currentIndex]
      record[answerIndex] = {
        index: contentIndex,
        score: contentItem.score
      }
      this.setData({
        [`answerRecord[${currentIndex}]`] : record
      })
      let timer = setTimeout(() => {
        this.setData({
          isCanClick:true
        })
        this.isShowToFalse()
        this.setData({
          [`questionData[${contentItem.toIndex}].isShow`]:true
        })
        clearTimeout(timer)
      }, 200)
      //最后一题的时候需判断是否可提交
      if (this.data.currentIndex + 1 === this.data.scaleTitleData.length) {
        this.canSubmit()
      }
    }
  },
  //上一题
  prev() {
    //点击上一题的时候，要把上一题的答题记录清除，不然你不知道下次会走另一个分支，数据会插入错误
    //当前题目答题数据也要清空，因为你不知道他已经答了一半去点上一题的
    this.setData({
      [`answerRecord[${this.data.currentIndex}]`]:{},
      currentIndex:this.data.currentIndex - 1,
    })
    this.setData({
      [`answerRecord[${this.data.currentIndex}]`]:{},
      isCanSubmit:false
    })
    this.isShowToFalse()
    this.setData({
      [`questionData[0].isShow`]:true
    })
    //答题记录写入缓存(续答功能)
    wx.setStorageSync('answerRecordCache05', {
      currentIndex: this.data.currentIndex,
      answerRecord: this.data.answerRecord
    })
  },
  //提交
  submit: debouce(function () {
    //验证数据的完整性
    console.log(this.data.answerRecord)
    if (!checkAnswerRecord(this.data.answerRecord)) {
      wx.showModal({
        showCancel: false,
        content: '抱歉，数据不完整，请稍后再试'
      })
      return
    }
    //拿到最终数据
    let sendDataScore = sendAnswerScore(this.data.answerRecord)	//分数
		let sendDataOption = sendAnswerOption(this.data.answerRecord)	//选项
    console.log('sendDataScore', sendDataScore)
    this.oldSubmit(sendDataScore,sendDataOption)
  }, 1000, true),
  //循环将选项数据中的isShow都变为false
  isShowToFalse() {
    this.data.questionData.forEach((value, index) => {
      this.setData({
        [`questionData[${index}].isShow`]:false
      })
    })
  },
  //判断最后一题的时候，是否可以提交，需满足
  //1.用户选择的未发生或一年前 => 通过
  //2.对象长度等于4或者5,并且等于4时候的第四项等于0('无影响') => 通过
  canSubmit() {
    let keys = Object.keys(this.data.answerRecord[this.data.currentIndex])
    if (this.data.answerRecord[this.data.currentIndex][0].index === 0 ||
      this.data.answerRecord[this.data.currentIndex][0].index === 1) {
      this.setData({
        isCanSubmit:true
      })
    } else if ((keys.length === 4 && this.data.answerRecord[this.data.currentIndex][4].index === 0) ||
      keys.length === 5) {
      this.setData({
        isCanSubmit:true
      })
    } else {
      this.setData({
        isCanSubmit:false
      })
    }
  },
  //原先的提交逻辑，不敢动，原封不动拿过来
  oldSubmit(sendDataScore,sendDataOption) {
    let that = this;
    if (this.data.flag && !this.data.disab) {
      this.setData({
        flag:false
      })
      wx.showLoading({
        title: '上传中...',
        mask: true
      });
      
      var user = wx.getStorageSync('user');
      var lb_descript = wx.getStorageSync('lb_descript');
      var lb_tp = wx.getStorageSync('lb_tz');
      var user_stime = formatSeconds(this.data.takeTime)
      if (lb_tp == '1') {
        var data = {
          user_stime: user_stime,
          user_answer: sendDataScore,
          answer: sendDataOption,
          user_number: lb_descript.desc.z_openid,
          measure_id: lb_descript.id[0]
        };
      } else {
        var data = {
          user_stime: user_stime,
          user_answer: sendDataScore,
          answer: sendDataOption,
          user_number: user.openid,
          measure_id: lb_descript.id[0],
          g_id: wx.getStorageSync('g_id')
        };
      }

      console.log(data);
      
      data.unitid = lb_descript.desc.unitid;
      var uploadData = setTimeout(() => {
        wx.hideLoading();
        wx.showToast({
          icon: 'none',
          title: '您当前的网络不稳定，请检查网络重新提交',
          duration: 2000
        });
        this.setData({
          flag:true
        })
      }, 5000);
      var url = HOST_xinli + 'xinli/index.php/Api/add_res';
      fetchPostN(url,data,(err,res)=>{
        clearTimeout(uploadData);
        if (+res == 0) {
          wx.showModal({
            showCancel: false,
            title: "提交失败，请重新提交。"
          })
          return;
        }
        var data1 = {};
        var ti_title = this.data.scaleData.measure_name;
        var lb_descript = wx.getStorageSync("lb_descript");

        data1.g_time = lb_descript.desc.g_time || lb_descript.desc.time;
        data1.measure_name = ti_title;
        data1.res_id = res;
        data1.user_stime = user_stime;
        var lb_tz = wx.getStorageSync('lb_tz');
        if (lb_tz == '1') {
          var unitid = wx.getStorageSync("unitid");
          data1.unitid = unitid;
          data1.z_openid = lb_descript.desc.z_openid;
          data1.t_openid = lb_descript.desc.t_openid;
          data1.openid = lb_descript.desc.z_openid;
          data1.is_type = 0;
          data1.measure_id = lb_descript.id[0];
        } else {
          data1.z_openid = user.openid;
          data1.t_openid = lb_descript.desc.t_openid;
          data1.openid = user.openid;
          data1.is_type = 1;
          data1.unitid = lb_descript.desc.unitid;
          data1.measure_id = lb_descript.id[0];
        }
        var urls = HOST + 'wechat.php?s=Home/del_vip'
        fetchPost(urls,data1,(err,res)=>{
          that.setData({
            flag: true
          })
          if (res == 1 || res == 0) {
            wx.removeStorageSync('lb_swiper_con');
            //删除答题记录缓存
            wx.removeStorageSync('answerRecordCache05')
            //删除计时
            wx.removeStorageSync('takeTime05')
            wx.hideLoading();
          }else {
            wx.hideLoading()
            wx.showToast({
              title: '请稍后再试',
              icon: 'none',
              duration: 2000
            })
          }
          if (res == 1) {
            // clearTimeout(timer)
            wx.showToast({
              title: '上传成功',
              icon: 'success',
              duration: 2000
            })
            setTimeout(function () {
              var lb_tz = wx.getStorageSync('lb_tz');
              if (lb_tz == '1') {
                wx.reLaunch({
                  url: '/pages/info1/info1?otype=1&otype1=1',
                  success: function () {
                    that.setData({
                      flag: true
                    })
                  }
                })
              } else {
                wx.reLaunch({
                  url: '/pages/info/info?otype=1&otype1=1&ishow=1',
                  success: function () {
                    that.setData({
                      flag: true
                    })
                  }
                })
              }
            }, 2000)
          } else if (res == 0) {
            wx.showToast({
              title: '上传成功',
              icon: 'success',
              duration: 2000
            })
            setTimeout(function () {
              wx.removeStorageSync('tplbDetail')
              wx.removeStorageSync('weiLb')
              wx.reLaunch({
                url: '/pages/record/record',
                success: function () {
                  that.setData({
                    flag: true
                  })
                  wx.removeStorageSync('lb_descript')
                }
              })
            }, 2000)
          } else {
  
          }
        })
      })
    }
  }
})