/*
	数据说明：数据为dati05.vue使用
	数据逻辑：数据已在下方注释，详细逻辑如下
	判断
	  回答 1=>'一年内' 让被试选择 该事件发生次数为 1=>"1次",2=>"2次",3=>"3次",4=>"4次以上"
	
	  回答 2=>'长期性' 让被试选择 该事件持续时间为 1=>"半年之内",2=>"半年以上"
	
	  随后
			选择性质 1=>'好事 ',2=>'坏事'
	  然后判断 
			精神影响程度 0=>'无影响',1=>'轻度',2=>"中度",3=>"重度",4=>"极重"	
		如果选择 无影响，则直接跳下一题。
	  
	  否则
		选择 影响持续时间 1=>"三月内",2=>"半年内",3=>"一年内",4=>"一年以上"
		
	数据层级不易再深，所以默认导出的数据(exports default)用数据的下标index来区分与编程
	index值代表如下:
	0 0=>'未发生 ',0=>'一年前',1=>'一年内',2=>'长期性'
	1 1=>"1次",2=>"2次",3=>"3次",4=>"4次以上"
	2 1=>"半年之内",2=>"半年以上"
	3 1=>'好事 ',2=>'坏事'
	4 0=>'无影响',1=>'轻度',2=>"中度",3=>"重度",4=>"极重"
	5 1=>"三月内",2=>"半年内",3=>"一年内",4=>"一年以上"
*/
export default [
	{
		isShow:true,			//默认显示第一项
		subtitle:'事件发生时间',//副标题
		content:[{
			toIndex: 0	,//跳转目标,跳转到该数组的某个下标(0 为直接跳转下一个题目)
			score: 0,
			title: '未发生'
		},
		{
			toIndex: 0	,//跳转目标,nextQuestion为跳转下一组大题
			score: 0,
			title: '一年前'
		},
		{
			toIndex: 1	,//跳转到发生次数
			score: 1,
			title: '一年内'
		},
		{
			toIndex: 2	,//跳转到1=>"半年之内",2=>"半年以上"
			score: 2,
			title: '长期性'
		}],
	},
	{
		isShow:false,
		subtitle:'该事件发生次数为',			//副标题
		content:[{
			toIndex: 	3,
			score: 1,
			title: '1次'
		},
		{
			toIndex: 	3,
			score: 2,
			title: '2次'
		},
		{
			toIndex: 	3,
			score: 3,
			title: '3次'
		},
		{
			toIndex: 	3,
			score: 4,
			title: '4次以上'
		}],
	},
	{
		isShow:false,
		subtitle:'该事件持续时间为',
		content:[{	
			toIndex: 	3,
			score: 1,
			title: '半年之内'
		},
		{
			toIndex: 	3,
			score: 2,
			title: '半年以上'
		}],
	},
	{
		isShow:false,
		subtitle:'性质',
		content:[{	
			toIndex: 	4,
			score: 1,
			title: '好事'
		},
		{
			toIndex: 	4,
			score: 2,
			title: '坏事'
		}],
	},
	{
		isShow:false,
		subtitle:'精神影响程度',
		content:[{	
			toIndex: 	0,
			score: 0,
			title: '无影响'
		},
		{
			toIndex: 	5,
			score: 1,
			title: '轻度'
		},
		{
			toIndex: 	5,
			score: 2,
			title: '中度'
		},
		{
			toIndex: 	5,
			score: 3,
			title: '重度'
		},{
			toIndex: 	5,
			score: 4,
			title: '极重'
		}],
	},
	{
		isShow:false,
		subtitle:'影响持续时间',
		content:[{	
			toIndex: 	0,
			score: 1,
			title: '三月内'
		},
		{
			toIndex: 	0,
			score: 2,
			title: '半年内'
		},
		{
			toIndex: 	0,
			score: 3,
			title: '一年内'
		},
		{
			toIndex: 	0,
			score: 4,
			title: '一年以上'
		}]
	}
]

//答题记录的保存格式
// [
// 	{0:{index:0,score:0}},	//选择未发生或一年前，key为选项数组的索引，index为选项数组中content的索引,score为分数
// 	{0:{index:1,score:0},1:{index:4,score:4},2:{index:1,score:0},3:{index:1,score:0},4:{index:4,score:3}},	//一年内
// ]